#include "pairs.hh"

Level Wily4 =
{
	9, // level number
	"Wily4",

	// screens:
	{
		{
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|  #        ##"   "                "
		"##|  ?        ##"   "                "
		"##|    #     ###"   "                "
		"##|    ?     ?##"   "                "
		"##?       #   ##"   "                "
		"##        ?   ##"   "        Y       "
		"##    ####    ##"   "                "
		"##^^^^####^^^^##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 0 // monster graphics index
		,Up| LevelBegin},
		{
		"##|#############"   "                "
		"##|#############"   "                "
		"##|???????????##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		, 0 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##??????????####"   "                "
		"##          ####"   "         P      "
		"##      ??  ????"   "                "
		"##      ??      "   "                "
		"##      ??      "   "                "
		"##      ??      "   "                "
		"##      ??      "   "                "
		"##      ??      "   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##..##..##..##.."   "       .       ."
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##..##..##..##.."   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"######..##..####"   "       .   .    "
		"##..##..##..####"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##..##..##..##.."   "       .       ."
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##..##..##..##.."   "                "
		"################"   "       v        "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"###############."   "                "
		"###############."   "                "
		"########???????."   "                "
		"########       ."   "                "
		"########|#######"   "                "
		"########|?????##"   "                "
		"########|     ##"   "                "
		"########|     ##"   "                "
		"..###########|##"   "                "
		"..######?????|##"   "                "
		"........     |##"   "                "
		"........     |##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"....############"   "                "
		"....############"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"..............#."   "                "
		"................"   "                "
		"................"   "                "
		"..#.*------/////"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"^^^^^^^^^^^^^^^^"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Right},
		{
		"################"   "                "
		"############__##"   "                "
		"..............##"   "                "
		"..............##"   "             O  "
		"...|########==##"   "                "
		"...|........####"   "                "
		"..............##"   "                "
		"..............##"   "                "
		"/---------------"   "                "
		"..............##"   "      U    W    "
		"......#....#..##"   "                "
		"..............##"   "                "
		"^^^^^^^^^^^^^^##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 1 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##????????????##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "                "
		"..            ##"   "        Y       "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 2 // monster graphics index
		,Up| RestartPointA},
		{
		"################"   "                "
		"################"   "                "
		"##????????????##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "                "
		"..            ##"   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 3 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##????????????##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "                "
		"..            ##"   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 4 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##????????????##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "                "
		"..            ##"   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 5 // monster graphics index
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##??????????????"   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"__              "   "                "
		"..              "   "                "
		"..              "   "        Y       "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 6 // monster graphics index
		,RestartPointB| Right},
		{
		"################"   "                "
		"################"   "                "
		"??????????????##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              DD"   "              SS"
		"              DD"   "              SS"
		"              DD"   "              SS"
		"              DD"   "            P SS"
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		, 7 // monster graphics index
		,Shutter},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"........222222.."   "                "
		"........222222.."   "                "
		"......11111222.."   "                "
		"......11111222.."   "                "
		"......11222222.."   "                "
		"......11222222.."   "                "
		"........2222...."   "                "
		"........2222...."   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		, 7 // monster graphics index
		,End},
	},

	// palette
	{
		15, 32,  0,  2, 
		15, 48, 39, 23, 
		15, 28, 11, 15, 
		15, 32,  0, 60, 

		15, 44, 17, 15, 
		15, 32, 56, 15, 
		15, 48, 42, 15, 
		15, 48, 42, 15, 

		15, 32,  0,  2, 
		15,  0, 32, 16, 
		15, 16, 32, 16, 
		15, 32,  0, 60, 
	},

	// after doors palette not used in wily stages
	{},

	// actives
	{
		Active( 2, 2, 0x80,0x60, 0xA0,0x80 ),
		Active( 2, 2, 0x80,0x80, 0xA0,0xA0 ),
		Active( 2, 2, 0x80,0xA0, 0xA0,0xC0 ),
	},

	// enemies
	{
		Enemy( 0, 0x10,0xFF, 0x6 ),
		Enemy( 1, 0x10,0xFF, 0x6 ),
		Enemy( 2, 0x10,0xFF, 0x2C ),
	},

	// level gfx (id, count) (max 15); id is block*4+bank
	{
		{ 0x40, 9 }, { 0x92, 4 }, { 0xE2, 1 }, { 0xD8, 1 }, 
		{ 0x5E, 1 }, { 0xC0, 2 }, { 0x43, 4 }, { 0xD8, 2 }, 
		{ 0x63, 8 }, 
	},

	// monster gfx tables (max 11) (5 tiles, 2*3bytepalette)
	{
		{ { 0x6E, 0x92, 0x96, 0x66, 0x72, }, { 48,42,15, 48,42,15,} },
		{ { 0x72, 0xAE, 0xB2, 0x7A, 0x7E, }, { 48,21,15, 48,17,15,} },
		{ { 0x80, 0x84, 0x88, 0x8C, 0x4A, }, { 39,21,15, 48,38,15,} },
		{ { 0x90, 0x94, 0x98, 0x5A, 0x42, }, { 32,21,15, 39,21,15,} },
		{ { 0xA0, 0xA4, 0xA8, 0xAC, 0x46, }, { 32,33,15, 48,38,15,} },
		{ { 0x70, 0x74, 0x78, 0x7C, 0x7B, }, { 39,21,15, 32,0,2,} },
		{ { 0x7A, 0xFE, 0xDE, 0x7A, 0x7E, }, { 39,21,15, 48,17,15,} },
		{ { 0xEA, 0xEE, 0xF2, 0xFB, 0xFF, }, { 48,21,15, 52,21,5,} },
	},

	0x00, // Arrival input

	Wily4Ascii, Wily4Char
};
